<?php
define('WP_INSTALLING', true);

function wph_die($message, $title = '') {
	/* header('Content-Type: text/html; charset=utf-8'); */

	if ( empty($title) )
		$title = __('WordPress &rsaquo; Error');
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<title><?php echo $title ?></title>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
	<style media="screen" type="text/css">
	<!--
	html {
		background: #eee;
	}
	body {
		background: #fff;
		color: #000;
		font-family: "Times New Roman", serif;
		margin-left: 20%;
		margin-right: 20%;
		padding: .2em 2em;
	}
	
	.hebrew {
		unicode-bidi: embed;
		direction: rtl;
	} /* WPH - directionality */
	
	h1 {
		color: #006;
		font-size: 18px;
		font-weight: lighter;
		text-align: center;
	}

	h2 {
		font-size: 16px;
	}

	p, li, dt {
		line-height: 140%;
		padding-bottom: 2px;
	}

	ul, ol {
		padding: 5px 5px 5px 20px;
	}
	#logo {
		margin-bottom: 2em;
	}
	.step a, .step input {
		font-size: 2em;
	}
	td input {
		font-size: 1.25em;
	}
	td {
	padding-right: 1.0em;
	}
	td, th {
	vertical-align: top;
	}
	.step, th {
		text-align: right;
		padding-bottom: 3.0em;
	}
	#footer {
		text-align: center;
		border-top: 1px solid #ccc;
		padding-top: 1em;
		font-style: italic;
	}
	-->
	</style>
</head>
<body>
	<div class="hebrew" dir="rtl">
	<h1 id="logo"><img alt="וורדפרס בעברית" src="wp-admin/images/wordpress-logo.png" /></h1>
	<p><?php echo $message; ?></p>
	<p id="footer"><a href="http://www.trans.co.il/wp">וורדפרס בעברית</a>, מערכת כתיבה אישית</p>
	</div>
	</body>
</html>
<?php

	die();
}

if (!file_exists('../wp-config.php')) wph_die("לא מצאתי קובץ wp-config.php תקין. האם יצרת קובץ wp-config.php באמצעות הקובץ wp-config-sample.pho, עם כל ההגדרות הרלבנטיות?", "וורדפרס בעברית: בעיה"); /* WPH - properly wraped Hebrew error message */ 
require('../wp-config.php');
timer_start();
require_once(ABSPATH . '/wp-admin/upgrade-functions.php');

$step = $_GET['step'];
if (!$step) $step = 0;
header( 'Content-Type: text/html; charset=utf-8' );
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
	<title>וורדפרס בעברית &rsaquo; שדרוג בסיס הנתונים</title> <?php /* WPH - Hebrew title, encoding should be first thing in header */ ?> 
	<style media="screen" type="text/css">
	<!--
	html {
		background: #eee;
	}
	body {
		background: #fff;
		color: #000;
		font-family: "Times New Roman", serif; /* WPH - font specificity */
		margin-left: 20%;
		margin-right: 20%;
		padding: .2em 2em; unicode-bidi: embed; direction: rtl; /* WPH - directionality */
	}
	
	h1 {
		color: #006;
		font-size: 18px;
		font-weight: lighter;
	}
	
	h2 {
		font-size: 16px;
	}
	
	p, li, dt {
		line-height: 140%;
		padding-bottom: 2px;
	}

	ul, ol {
		padding: 5px 5px 5px 20px;
	}
	#logo {
		margin-bottom: 2em;
	}
.step a, .step input {
	font-size: 2em;
}
.step, th {
	text-align: right;
}
#footer {
text-align: center; border-top: 1px solid #ccc; padding-top: 1em; font-style: italic;
}
	-->
	</style>
</head>
<body>
<h1 id="logo"><img alt="WordPress" src="images/wordpress-logo.png" /></h1>
<?php
switch($step) {

	case 0:
	$goback = attribute_escape(stripslashes(wp_get_referer()));
?> 
<p><?php _e('This file upgrades you from any previous version of WordPress to the latest. It may take a while though, so be patient.'); ?></p> 
	<h2 class="step"><a href="upgrade.php?step=1&amp;backto=<?php echo $goback; ?>"><?php _e('Upgrade WordPress &raquo;'); ?></a></h2>
<?php
	break;
	
	case 1:
	$wp_current_db_version = __get_option('db_version');
	if ( $wp_db_version != $wp_current_db_version ) {
		wp_cache_flush();
		make_db_current_silent();
		upgrade_all();
		wp_cache_flush();
	}

	if ( empty( $_GET['backto'] ) )
		$backto = __get_option('home');
	else
		$backto = attribute_escape(stripslashes($_GET['backto']));
?> 
<h2><?php _e('Step 1'); ?></h2> 
	<p><?php printf(__("There's actually only one step. So if you see this, you're done. <a href='%s'>Have fun</a>!"),  $backto); ?></p>

<!--
<pre>
<?php printf(__('%s queries'), $wpdb->num_queries); ?>

<?php printf(__('%s seconds'), timer_stop(0)); ?>
</pre>
-->

<?php
	break;
}
?> 
</body>
</html>
